Rem the compare utility for QB64 PD 2025.
Rem   compare equivalency of 2 directories or difference of 2 files.

' declare filename buffer
Const xbuflen = 32767 ' can be changed
Dim Shared xbuffer1 As String * xbuflen
Dim Shared xbuffer2 As String * xbuflen

' declare library constants.
Const MAX_PATH = 260
Const MAX_PATH2 = 520
Const INVALID_HANDLE_VALUE = -1
Const ERROR_FILE_NOT_FOUND = 2
Const ERROR_NO_MORE_FILES = &H12

' declare external libraries.
Declare Dynamic Library "kernel32"
   Function FindFirstFileA~%& (ByVal lpFileName~%&, ByVal lpFindFileData~%&)
   Function FindNextFileA& (ByVal hFindFile~%&, ByVal lpFindFileData~%&)
   Function FindFirstFileW~%& (lpwszFileName$, ByVal lpFindFileData~%&)
   Function FindNextFileW& (ByVal hFindFile~%&, ByVal lpFindFileData~%&)
   Function FindClose& (ByVal hFindFile~%&)
End Declare

Type FILETIME
   dwLowDateTime As _Unsigned Long
   dwHighDateTime As _Unsigned Long
End Type

Type SYSTEMTIME
   wYear As Integer
   wMonth As Integer
   wDayOfWeek As Integer
   wDay As Integer
   wHour As Integer
   wMinute As Integer
   wSecond As Integer
   wMilliseconds As Integer
End Type

Type WIN32_FIND_DATAA
   dwFileAttributes As _Unsigned Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As _Unsigned Long
   nFileSizeLow As _Unsigned Long
   dwReserved0 As _Unsigned Long
   dwReserved1 As _Unsigned Long
   cFileName As String * Max_path
   cAlternateFileName As String * 14
End Type

Declare Library
   Function GetShortPathName& (InP$, OutP$, ByVal length&)
End Declare

Const Nul = ""
Const Quote = Chr$(34)
Dim Shared t1 As Long
Dim Shared ControlBreak As Integer

' start main input loop
On Error GoTo Hell
_ScreenMove _Middle
On Timer(1) StatusLine
Timer On
t1 = _FreeTimer
On Timer(t1, 1) Break
Timer(t1) On
VarQ = _Exit
Color 14
Print "Dir/File compare utility"
Call StatusLine
StartMenu:
Do
   Color 15
   Print "Enter (D)ir/(F)ile/(Q)uit?";
   Do
      _Limit 50
      x$ = InKey$
      If ControlBreak Then ControlBreak = False: GoTo StartMenu
      If Len(x$) Then
         x$ = LCase$(x$)
         If x$ = "d" Then
            Print
            GoSub CompareFunc
            Exit Do
         Else
            If x$ = "f" Then
               Print
               GoSub CompareFunc2
               Exit Do
            Else
               If x$ = "q" Then
                  Timer Off
                  Timer(t1) Off
                  Print
                  Color 7
                  End
               End If
            End If
         End If
      End If
   Loop
Loop
Color 7
End

' critical error trap.
Hell:
Timer Off
Timer(t1) Off
Print
Print "Critical error line"; _ErrorLine
Color 7
End

' compare contents of 2 directoires.
CompareFunc:
Print "Count only(y/n)?";
Do
   _Limit 50
   x$ = InKey$
   If ControlBreak Then ControlBreak = False: GoTo CompareFunc
   If Len(x$) Then
      x$ = LCase$(x$)
      If x$ = "n" Then
         Print
         CountOnly = 0
         Exit Do
      End If
      If x$ = "y" Then
         Print
         CountOnly = -1
         Exit Do
      End If
   End If
Loop
Color 15
f$ = _SelectFolderDialog$("Enter first directory", _CWD$)
g$ = _SelectFolderDialog$("Enter second directory", _CWD$)
If f$ <> "" Then
   If g$ <> "" Then
      If _DirExists(f$) And _DirExists(g$) Then
         Color 7
         Call VerifyFiles(f$, g$, CountOnly)
         Return
      End If
   End If
End If
Color 15
Print "Paths not found."
Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
Return

' compare 2 files.
CompareFunc2:
Print "List only(y/n)?";
Do
   _Limit 50
   x$ = InKey$
   If ControlBreak Then ControlBreak = False: GoTo CompareFunc2
   If Len(x$) Then
      x$ = LCase$(x$)
      If x$ = "n" Then
         Print
         ByteList = 0
         Exit Do
      End If
      If x$ = "y" Then
         Print
         ByteList = -1
         Exit Do
      End If
   End If
Loop

f$ = _OpenFileDialog$("Enter first file", _CWD$)
g$ = _OpenFileDialog$("Enter second file", _CWD$)
If f$ <> "" Then
   If g$ <> "" Then
      If _FileExists(f$) And _FileExists(g$) Then
         Color 7
         Call VerifyFiles2(f$, g$, ByteList)
         Return
      End If
   End If
End If
Color 15
Print "Files not found."
Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
Return

' compare 2 directories.
Sub VerifyFiles (Var1$, Var2$, VarX)
   Dim Attribute As _Unsigned Long
   Dim ASCIIZ As String * 260
   Dim finddata As WIN32_FIND_DATAA
   Dim Wfile.Handle As _Unsigned _Offset

   Dim Verify1(1) As String
   Dim Verify2(1) As String
   Dim VerifyCount1 As Single
   Dim VerifyCount2 As Single
   VerifyCount1 = 0!
   VerifyCount2 = 0!

   Dim SizeArray1(1) As Double
   Dim SizeArray2(1) As Double

   ' make search path
   Var3$ = Var1$
   If Right$(Var3$, 1) <> "\" Then
      Var3$ = Var3$ + "\"
   End If
   TempPath1$ = Var3$
   Var3$ = Var3$ + "*.*"

   Var4$ = Var2$
   If Right$(Var4$, 1) <> "\" Then
      Var4$ = Var4$ + "\"
   End If
   TempPath2$ = Var4$
   Var4$ = Var4$ + "*.*"
   If VarX Then
      Color 15, 0
      Print "Wait.."
   End If

   ' store first path files
   ASCIIZ = Var3$ + Chr$(0)
   Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata))
   If Wfile.Handle <> INVALID_HANDLE_VALUE Then
      Do
         Attribute = finddata.dwFileAttributes
         ' check for directory
         If (Attribute And &H10) <> &H10 Then
            ' store directory name
            Directory$ = finddata.cFileName
            Directory$ = Left$(Directory$, InStr(Directory$, Chr$(0)) - 1)
            ' check directory name
            If Directory$ <> "." And Directory$ <> ".." Then
               VerifyCount1 = VerifyCount1 + 1!
               ReDim _Preserve Verify1(VerifyCount1) As String
               Verify1(VerifyCount1) = Directory$
               ReDim _Preserve SizeArray1(VerifyCount1) As Double
               SizeArray1(VerifyCount1) = finddata.nFileSizeHigh * &H100000000~&& Or finddata.nFileSizeLow
            End If
         End If
      Loop While FindNextFileA(Wfile.Handle, _Offset(finddata))
      x = FindClose(Wfile.Handle)
   End If

   ' store second path files
   ASCIIZ = Var4$ + Chr$(0)
   Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata))
   If Wfile.Handle <> INVALID_HANDLE_VALUE Then
      Do
         Attribute = finddata.dwFileAttributes
         ' check for directory
         If (Attribute And &H10) <> &H10 Then
            ' store directory name
            Directory$ = finddata.cFileName
            Directory$ = Left$(Directory$, InStr(Directory$, Chr$(0)) - 1)
            ' check directory name
            If Directory$ <> "." And Directory$ <> ".." Then
               VerifyCount2 = VerifyCount2 + 1!
               ReDim _Preserve Verify2(VerifyCount2) As String
               Verify2(VerifyCount2) = Directory$
               ReDim _Preserve SizeArray2(VerifyCount2) As Double
               SizeArray2(VerifyCount2) = finddata.nFileSizeHigh * &H100000000~&& Or finddata.nFileSizeLow
            End If
         End If
      Loop While FindNextFileA(Wfile.Handle, _Offset(finddata))
      x = FindClose(Wfile.Handle)
   End If

   ' check files found
   If VerifyCount1 = 0! Or VerifyCount2 = 0! Then
      Print "No matching files found."
      Exit Sub
   End If

   ' compare both arrays
   Continuous = 0
   LineCount = 2
   LineBreak = 23
   LineBreak = LineBreak - 2
   Found = 0
   If VarX = 0 Then
      Color 15, 0
      Print "Filename1", "Filename2", "   Filesize"
      Print "---------", "---------", "   --------"
   End If
   MatchingBytes# = 0#
   For Var1! = 1! To VerifyCount1
      For Var2! = 1! To VerifyCount2
         If Verify1(Var1!) = Verify2(Var2!) Then
            If SizeArray1(Var1!) = SizeArray2(Var2!) Then
               VarZ = FileCompare(Var1$, Var2$, Verify1(Var1!), Verify2(Var2!))
               If VarZ = -2 Then Exit Sub ' escape
               If VarZ = -1 Then ' file found
                  MatchingBytes# = MatchingBytes# + SizeArray1(Var1!)
                  Found = Found + 1
                  Color 14, 0
                  File1$ = AmbiguateFile$(TempPath1$ + Verify1(Var1!))
                  File2$ = AmbiguateFile$(TempPath2$ + Verify2(Var2!))
                  Call Suffix(SizeArray1(Var1!), S$) ' 1,024.0 KB
                  z$ = Space$(11 - Len(S$)) + S$
                  If VarX = 0 Then
                     Print UCase$(File1$), UCase$(File2$), z$
                  End If
                  LineCount = LineCount + 1
                  If LineCount >= LineBreak Then
                     LineCount = 2
                     If Continuous = 0 Then
                        If VarX = 0 Then
                           Color 15, 0
                           Call MorePrompt("-more(y/n/c)-", "ync " + Chr$(13) + Chr$(27), Outpt$)
                           If Outpt$ = Chr$(27) Then Exit Sub
                           If Outpt$ = "c" Then Continuous = -1
                           If Outpt$ = "n" Then
                              Exit Sub
                           End If
                           If Continuous = 0 Then
                              Color 15, 0
                              Print "Filename1", "Filename2", "   Filesize"
                              Print "---------", "---------", "   --------"
                           End If
                        End If
                     End If
                  End If
               End If
            End If
         End If
      Next
   Next
   If Found = 0 Then
      Color 14
      Print "No matching files found."
   Else
      Color 14
      Print "Matching files:"; Found; "bytes: "; FormatString$(MatchingBytes#)
   End If
   If LineCount Then
      If VarX = 0 Then
         Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
      End If
   End If
End Sub

' compare 2 files.
Sub VerifyFiles2 (Var1$, Var2$, VarX)
   Dim Byte1 As String * 1
   Dim Byte2 As String * 1
   X = FreeFile
   Open Var1$ For Binary Shared As #X Len = xbuflen
   Y = FreeFile
   Open Var2$ For Binary Shared As #Y Len = xbuflen
   If LOF(X) <> LOF(Y) Then
      Close X, Y
      Print "Files not same size."
      Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
      Exit Sub
   End If
   If LOF(X) = 0 And LOF(Y) = 0 Then
      Close X, Y
      Print "Files both zero."
      Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
      Exit Sub
   End If
   Count# = 0#
   Percent = 0
   Last.Percent = 0
   File.Size = LOF(X)
   Print "Verifying files";
   VarX2 = CsrLin
   Block# = 0#
   Do Until EOF(X)
      GoSub Display.Percent
      Get #X, , xbuffer1
      Get #Y, , xbuffer2
      Block# = Block# + 1#
      If xbuffer1 <> xbuffer2 Then
         Close #X, #Y
         Print ""
         If VarX Then
            GoTo DisplayX
         End If
         Print "Files do not match."
         Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
         Exit Sub
      End If
      If InKey$ = Chr$(27) Then
         Close #X, #Y
         Print ""
         Print "Files matching interrupted."
         Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
         Exit Sub
      End If
   Loop
   Print ""
   Close #X, #Y
   Print "Files match: " + FormatString$(File.Size) + " bytes checked."
   Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
   Exit Sub

   DisplayX:
   Close #X, #Y
   X = FreeFile
   Open Var1$ For Binary Shared As #X Len = xbuflen
   Y = FreeFile
   Open Var2$ For Binary Shared As #Y Len = xbuflen

   Color 15
   Print "Offset         Byte Hex    ASCII"
   Print "-------------  ---- -----  -------"

   LineCount = 2
   LineBreak = 23
   Z# = 0#
   For V# = 1# To Block# - 1#
      Get #X, , xbuffer1
      Get #Y, , xbuffer2
      Z# = Z# + xbuflen
   Next
   Do Until EOF(X)
      Get #X, , xbuffer1
      Get #Y, , xbuffer2
      For C# = 1# To xbuflen
         Z# = Z# + 1#
         Byte1 = Mid$(xbuffer1, C#, 1#)
         Byte2 = Mid$(xbuffer2, C#, 1#)
         If Byte1 <> Byte2 Then
            V1$ = LTrim$(Str$(Z#)): V1$ = V1$ + Space$(15 - Len(V1$))
            V1$ = V1$ + Byte1 + "\" + Byte2 + "  "
            V2$ = Right$("00" + Hex$(Asc(Byte1)), 2) + "\" + Right$("00" + Hex$(Asc(Byte2)), 2)
            V3$ = Right$("000" + LTrim$(Str$(Asc(Byte1))), 3) + "\" + Right$("000" + LTrim$(Str$(Asc(Byte2))), 3)
            VX$ = V1$ + V2$ + "  " + V3$
            Color 7
            Print VX$
            LineCount = LineCount + 1
            If LineCount >= LineBreak Then
               LineCount = 0
               Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
               If Outpt$ = "n" Then
                  Exit Do
               End If
            End If
         End If
      Next
   Loop
   Close X, Y
   If LineCount Then
      Call MorePrompt("-more-", " " + Chr$(13), Outpt$)
   End If
   Exit Sub

   ' display percentage scanned in title
   Display.Percent:
   If File.Size > 0 Then
      Count# = Count# + xbuflen
      If Count# > File.Size Then
         Count# = File.Size
      End If
      Percent = (Count# / File.Size) * 100!
      Percent = Int(Percent)
      If Percent <> Last.Percent Then
         Last.Percent = Percent
         P$ = Right$(Str$(Percent + 1000%), 3) + "%"
         Locate VarX2, 1, 1
         Print "Verifying files "; P$;
         Var3x$ = Var1$
         For VarZ = Len(Var3x$) To 1 Step -1
            If Mid$(Var3x$, VarZ, 1) = "\" Then
               Var3x$ = Mid$(Var3x$, VarZ + 1)
               Exit For
            End If
         Next
         Var4x$ = Var2$
         For VarZ = Len(Var4x$) To 1 Step -1
            If Mid$(Var4x$, VarZ, 1) = "\" Then
               Var4x$ = Mid$(Var4x$, VarZ + 1)
               Exit For
            End If
         Next
         V$ = "COMPARE - " + Var3x$ + " to " + Var4x$ + " - " + P$
         _Title V$
      End If
   End If
   Return
End Sub

Sub MorePrompt (Input.String$, Input.Mask$, Output.String$)
   StartMore:
   Color 15, 0
   If Input.String$ = "-more-" Then
      Print Input.String$;
   Else
      Print Input.String$ + " ";
   End If
   Input.Char$ = Nul
   Locate , , 1
   Do
      _Limit 50
      Input.Char$ = InKey$
      If ControlBreak Then ControlBreak = False: GoTo StartMore
      If Len(Input.Char$) Then
         Input.Char$ = LCase$(Input.Char$)
         If InStr(Input.Mask$, Input.Char$) Then
            If Left$(Input.String$, 5) = "-more" Then
               Print
            Else
               If Input.Char$ = Chr$(13) Then
                  Print
               Else
                  Print Input.Char$
               End If
            End If
            Output.String$ = Input.Char$
            Exit Do
         End If
      End If
   Loop
End Sub

Function FileCompare (Path1$, Path2$, Filename1$, Filename2$)
   FileComp1$ = Path1$
   If Right$(FileComp1$, 1) <> "\" Then
      FileComp1$ = FileComp1$ + "\"
   End If
   FileComp1$ = FileComp1$ + Filename1$

   FileComp2$ = Path2$
   If Right$(FileComp2$, 1) <> "\" Then
      FileComp2$ = FileComp2$ + "\"
   End If
   FileComp2$ = FileComp2$ + Filename2$

   If _FileExists(FileComp1$) = 0 Then
      FileCompare = 0
      Exit Function
   End If

   If _FileExists(FileComp2$) = 0 Then
      FileCompare = 0
      Exit Function
   End If

   Count# = 0#
   Percent = 0
   Last.Percent = 0

   X = FreeFile
   Open FileComp1$ For Binary Shared As #X Len = xbuflen
   Y = FreeFile
   Open FileComp2$ For Binary Shared As #Y Len = xbuflen
   If LOF(X) = 0 And LOF(Y) = 0 Then
      Close #X, #Y
      FileCompare = -1
      Exit Function
   End If
   File.Size = LOF(X)
   Do Until EOF(X)
      GoSub Display.Percent
      Get #X, , xbuffer1
      Get #Y, , xbuffer2
      If xbuffer1 <> xbuffer2 Then
         Close #X, #Y
         FileCompare = 0
         Exit Function
      End If
      If InKey$ = Chr$(27) Then
         Close #X, #Y
         FileCompare = -2
         Exit Function
      End If
   Loop
   Close #X, #Y
   FileCompare = -1
   Exit Function

   ' display percentage scanned in title
   Display.Percent:
   If File.Size > 0 Then
      Count# = Count# + xbuflen
      If Count# > File.Size Then
         Count# = File.Size
      End If
      Percent = (Count# / File.Size) * 100!
      Percent = Int(Percent)
      If Percent <> Last.Percent Then
         Last.Percent = Percent
         P$ = Right$(Str$(Percent + 1000%), 3) + "%"
         Var3x$ = FileComp1$
         For VarZ = Len(Var3x$) To 1 Step -1
            If Mid$(Var3x$, VarZ, 1) = "\" Then
               Var3x$ = Mid$(Var3x$, VarZ + 1)
               Exit For
            End If
         Next
         Var4x$ = FileComp2$
         For VarZ = Len(Var4x$) To 1 Step -1
            If Mid$(Var4x$, VarZ, 1) = "\" Then
               Var4x$ = Mid$(Var4x$, VarZ + 1)
               Exit For
            End If
         Next
         V$ = "COMPARE - " + Var3x$ + " to " + Var4x$ + " - " + P$
         _Title V$
      End If
   End If
   Return
End Function

Function AmbiguateFile$ (Var$)
   ' declare subroutine variables
   Dim ASCIIZ1 As String * 260
   Dim ASCIIZ2 As String * 260
   VarX$ = Var$

   ' read 8.3 filename
   ASCIIZ1 = VarX$ + Chr$(0)
   ret = GetShortPathName(ASCIIZ1, ASCIIZ2, MAX_PATH)

   ' check function error
   If ret > 0 Then
      ' store 8.3 filename
      VarX$ = ASCIIZ2
      Imbedded = InStr(VarX$, Chr$(0))
      If Imbedded Then
         VarX$ = Left$(VarX$, Imbedded - 1)
      End If
   End If

   ' strip path
   For Imbedded = Len(VarX$) To 1 Step -1
      If Mid$(VarX$, Imbedded, 1) = "\" Then
         VarX$ = Mid$(VarX$, Imbedded + 1)
         Exit For
      End If
   Next

   ' strip drive
   If Mid$(VarX$, 2, 1) = ":" Then
      VarX$ = Mid$(VarX$, 3)
   End If
   AmbiguateFile$ = VarX$
End Function

Sub Suffix (Var#, Var3$)
   Rem B  (Byte) = 00x - 0FFx (hexidecimal zero-based)
   Rem KB (Kilobyte) = 1024 B
   Rem MB (Megabyte) = 1024 KB (1 MB B)
   Rem GB (Gigabyte) = 1024 MB
   Rem TB (Terabyte) = 1024 GB (1 MB MB)
   Rem PB (Petabyte) = 1024 TB
   Rem EB (Exabyte) = 1024 PB (1 MB TB)

   ' check double
   VarX# = Var#
   s$ = Str$(VarX#)
   If InStr(s$, "D") Then
      Var3$ = s$
      Exit Sub
   End If

   ' get sign
   If VarX# < 0# Then
      Sign = -1
      VarX# = Abs(VarX#)
   End If

   ' calculate bytes
   TempA = 0
   Do
      If VarX# >= 1024# Then
         VarX# = VarX# / 1024#
         TempA = TempA + 1
         If TempA = 6 Then
            Exit Do
         End If
      Else
         Exit Do
      End If
   Loop

   ' calculate byte string
   Var3$ = FormatString$(VarX#)
   If InStr(Var3$, ".") Then
      Var3$ = Left$(Var3$, InStr(Var3$, ".") + 1)
   Else
      Var3$ = Var3$ + ".0"
   End If

   ' calculate byte suffix
   Var$ = Nul
   If TempA > 0 Then
      Var$ = Mid$("KMGTPE", TempA, 1)
   End If
   Var3$ = Var3$ + " " + Var$ + "B"

   ' calculate byte sign
   If Sign Then
      Var3$ = "-" + Var3$
   End If
End Sub

Function FormatString$ (s#)
   x$ = ""
   s$ = Str$(s#)
   If InStr(s$, "D") Then ' return string
      FormatString$ = s$
      Exit Function
   End If
   If Left$(s$, 1) = "-" Then ' store sign
      e$ = "-"
      s$ = Mid$(s$, 2)
   End If
   s$ = LTrim$(s$) ' format string
   If InStr(s$, ".") Then
      q$ = Mid$(s$, InStr(s$, "."))
      s$ = Left$(s$, InStr(s$, ".") - 1)
   End If
   For l = Len(s$) To 3 Step -3
      x$ = Mid$(s$, l - 2, 3) + "," + x$
   Next
   If l > 0 Then
      x$ = Mid$(s$, 1, l) + "," + x$
   End If
   If Len(s$) < 3 Then
      x$ = s$
   End If
   If Right$(x$, 1) = "," Then
      x$ = Left$(x$, Len(x$) - 1)
   End If
   x$ = e$ + x$ + q$ ' construct string
   FormatString$ = x$
End Function

Sub StatusLine
   X = CsrLin
   Y = Pos(0)
   Locate 25, 1, 1
   Print "Compare utility "; Date$; " "; Time$;
   Locate X, Y, 1
End Sub

Sub Break
   VarQ = _Exit
   If VarQ Then
      Print
      Color 15
      Print "Exit(y/n)?";
      Do
         _Limit 50
         x$ = InKey$
         If Len(x$) Then
            x$ = LCase$(x$)
            If x$ = "y" Then
               Timer Off
               Timer(t1) Off
               Print
               Color 7
               End
            Else
               If x$ = "n" Then
                  ControlBreak = -1
                  Print
                  Exit Do
               End If
            End If
         End If
      Loop
   End If
End Sub


